#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <errno.h>
#include "lxmisc.h"
#include "misc.h"
#include "data.h"

void die_dlsym (sym, err)
	char *sym;
	char *err;
{
	log_err ("dlsym(", sym, "): ", err, 0,0);
	_exit(1);
}

void die_badenv (varname)
	char *varname;
{
	log_err ("bad environment variable usage: ", varname, 0,0,0,0);
	_exit(1);
}

void die_noconfig (void) {
	log_err ("no usable configuration file found", 0,0,0,0,0);
	_exit(1);
}

void die_open (file)
	char *file;
{
	log_err ("open (", file, "): ", strerror(errno), 0,0);
	_exit(1);
}

void die_nomem (void) {
	log_err ("out of memory", 0,0,0,0,0);
	_exit(1);
}

void die_general (str)
	char *str;
{
	log_err (str, ":", strerror(errno),0,0,0);
	_exit(1);
}

void warn_notreadable (file)
	char *file;
{
	log_warn (file, " exists, but is not readable", 0,0,0);
}

void log_err (s1, s2, s3, s4, s5, s6)
	char *s1,*s2,*s3,*s4,*s5,*s6;
{
	lx_gdputs (gderr, s1);
	if (s2) lx_gdputs (gderr, s2);
	if (s3) lx_gdputs (gderr, s3);
	if (s4) lx_gdputs (gderr, s4);
	if (s5) lx_gdputs (gderr, s5);
	if (s6) lx_gdputs (gderr, s6);
	lx_gdputs (gderr, "\n");
	lx_gdflush (gderr);
}

void log_warn (s1, s2, s3, s4, s5)
	char  *s1,*s2,*s3,*s4,*s5;
{
	log_err ("WARNING: ", s1, s2, s3, s4, s5);
}

void log_debug (level, s1, s2, s3, s4, s5)
	char    level,*s1,*s2,*s3,*s4,*s5;
{
        if (!naw_debug_noisy) return;
	if (level <= naw_debug_level) {
		char debugstr[] =
			{ 'D', 'E', 'B', 'U', 'G',
				'(', level + '0', ')', ':', ' ', 0 };
		log_err (debugstr, s1, s2, s3, s4, s5);
	}
}

