#include "lxmisc.h"
#include "misc.h"

/***************************************************************************
  gd_setup

  set up gdin, gdout, and gderr for use throughout the program

  returns nothing
 ***************************************************************************/

lx_gd *gdin;
lx_gd *gdout;
lx_gd *gderr;

void gd_setup (void) {
	static lx_gd _gdin;
	static lx_gd _gdout;
	static lx_gd _gderr;

	gdin  = &_gdin;
	gdout = &_gdout;
	gderr = &_gderr;

	if (lx_gdnew (gdin, 0, 512)) die_nomem();
	if (lx_gdnew (gdout, 1, 512)) die_nomem();
	if (lx_gdnew (gderr, 2, 512)) die_nomem();

}

