#define _GNU_SOURCE
#include <dlfcn.h>
#include <unistd.h>
#include <stdio.h>
#include "misc.h"

#ifdef NAW_PRELOAD
/***************************************************************************
  get_funcptr()
  
  finds the function symbol passed by sym
  returns a (void *) pointer to the function.
  always successful; dies otherwise.
 ***************************************************************************/

extern int connect();
extern int accept();
void *get_funcptr(sym)
	char *sym;
{
	char *dlerr;
        void (*function)();

#ifdef RTLD_NEXT
# define HAVE_RTLD_NEXT 1
#endif

#if HAVE_DYLIB
#  error "dylib calls are not implemented yet."
#elif HAVE_RTLD_NEXT && !defined(BROKEN_RTLD_NEXT)
	function = dlsym (RTLD_NEXT, sym);
	if (!function) {
		dlerr = (char *)dlerror();
		if (dlerr) {
			die_dlsym (sym, dlerr);
			_exit (1);
		} /* else, symbol is at address 0 */
	}
#elif HAVE_RTLD_NEXT && BROKEN_RTLD_NEXT
        void *handle;

        handle = dlopen (SYSLIB_CONNECT, RTLD_LAZY);
        if (!handle) {
            die_dlsym (sym, (char *)dlerror());
            _exit(1);
        }
	function = dlsym (handle, sym);
	if (!function) {
		dlerr = (char *)dlerror();
		if (dlerr) {
			die_dlsym (sym, dlerr);
			_exit (1);
		} /* else, symbol is at address 0 */
	}
        printf ("connect is at %p\n", connect);
        printf ("accept is at %p\n", accept);
        printf ("symbol %s is at: %p\n", sym, function);
        dlclose(handle);
#else
#  error
#  error "I don't know what dynamic loader to use."
#  error
#endif
	return function;
}

#endif /* NAW_PRELOAD */
