#include "lxmisc.h"
#include "misc.h"
#include "data.h"
#include "proto_data.h"

char auth_client (dat, gd)
	cfg_data *dat;
	lx_gd *gd;
{
	unsigned char proto, okay, *stage = "0";
	/* note: stage must not get above 9 */

	get_proto_from_banner (gd, dat, &proto, &okay);
	if (!okay) goto ERROR;

	log_debug (6, "get_proto_from_banner() returned okay", 0,0,0,0);

	if (proto == 0x01) {
		auth_data_proto1 adat;
		log_debug (2, "using protocol 0x01", 0,0,0,0);

		send_proto(gd, proto, &okay); if (!okay) goto ERROR;

		log_debug (6, "send_proto() returned okay", 0,0,0,0);

		proto1_send_auth1(gd, dat, &adat, &okay);
				++*stage; if (!okay) goto ERROR;

		log_debug (6, "proto1_send_auth1() returned okay", 0,0,0,0);

		proto1_recv_auth2(gd, dat, &adat, &okay);
				++*stage; if (!okay) goto ERROR;

		log_debug (6, "proto1_recv_auth2() returned okay", 0,0,0,0);

		proto1_send_auth3(gd, dat, &adat, &okay);
				++*stage; if (!okay) goto ERROR;

		log_debug (6, "proto1_send_auth3() returned okay", 0,0,0,0);

	} else {
		log_ip (INIT_CLI, dat, "no known protocols", 0,0, "from");
		
		return 1;
	}

	return 0;

ERROR:
	log_ip (INIT_CLI,dat,"authentication failed at stage ",stage,0,"to");
	return 1;
}
