#include "lxmisc.h"
#include "misc.h"
#include "data.h"
#include "proto_data.h"

char auth_server (dat, gd)
	cfg_data *dat;
	lx_gd *gd;
{
	unsigned char proto, okay, *stage = "0";
	/* note: stage must not get above 9 */

	send_banner (gd, dat, &okay);
	if (!okay) {
		log_ip (INIT_SRV, dat, "socket error during send", 0,0, "to");
		return 1;
	}

	log_debug (6, "send_banner() returned okay", 0,0,0,0);

	recv_proto (gd, &proto, &okay); if (!okay) goto ERROR;

	log_debug (6, "recv_proto() returned okay", 0,0,0,0);

	if (proto == 0x01) {
		auth_data_proto1 adat;
		log_debug (2, "using protocol 0x01", 0,0,0,0);

		proto1_recv_auth1(gd, dat, &adat, &okay);
				++*stage; if (!okay) goto ERROR;

		log_debug (6, "proto1_recv_auth1() returned okay", 0,0,0,0);

		proto1_send_auth2(gd, dat, &adat, &okay);
				++*stage; if (!okay) goto ERROR;

		log_debug (6, "proto1_send_auth2() returned okay", 0,0,0,0);

		proto1_recv_auth3(gd, dat, &adat, &okay);
				++*stage; if (!okay) goto ERROR;

		log_debug (6, "proto1_recv_auth3() returned okay", 0,0,0,0);

	} else {
		lx_s ns = {0};

		if (proto < 0x10) lx_strset (&ns, "0x0");
		else              lx_strset (&ns, "0x");

		lx_straddulong (&ns, (unsigned long) proto, 0x10);
		lx_check0(&ns);

		log_ip (INIT_SRV, dat, "protocol ",
				ns.s, " unsupported", "from");

		lx_free (&ns);
		return 1;
	}

	return 0;

ERROR:
	log_ip (INIT_SRV,dat,"authentication failed at stage ",stage,0,"from");
	return 1;
}
