#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include "misc.h"
#include "conf.h"

char *get_cfg_file (type)
	char type;
{
	char *env;

	/* environment variable? */

	if (type == INIT_CLI) env = getenv ("NAW_INIT_CLI_CFG");
	else /* INIT_SRV */   env = getenv ("NAW_INIT_SRV_CFG");

	if (env && cfg_perms_ok (env)) return (env);

	/* nope... home directory? */

	if ((env = getenv ("HOME"))) {
		int len = strlen(env);
		int len2 = len;
		char *clisub = "/."CONFIG_SUBDIR"/"CONFIG_CLIENT;
		char *srvsub = "/."CONFIG_SUBDIR"/"CONFIG_SERVER;
		char *sub;
		char *fn;

		sub = (type == INIT_CLI) ? clisub : srvsub;

		len += strlen(sub);

		fn = malloc (len + 1);

		*(fn + len) = 0;
		memmove (fn, env, len2);
		memmove (&fn[len2], sub, len - len2);

		if (cfg_perms_ok (fn)) return fn;
		free (fn);
	}


	/* nope... /etc? */
	{
		int len;
		char *clisub = CONFIG_ETC"/"CONFIG_SUBDIR"/"CONFIG_CLIENT;
		char *srvsub = CONFIG_ETC"/"CONFIG_SUBDIR"/"CONFIG_SERVER;
		char *sub;
		char *fn;

		sub = (type == INIT_CLI) ? clisub : srvsub;

		len = strlen(sub);

		fn = malloc (len + 1);

		*(fn + len) = 0;
		memmove (fn, sub, len);

		if (cfg_perms_ok (fn)) return fn;
		free (fn);
	}

	die_noconfig();
	return 0; /* control does not reach here */
}
