#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include "lxmisc.h"
#include "misc.h"

#define RANDOM_DEVICE "/dev/random"

char generate_randkey (rk, len)
	lx_s *rk;
	unsigned int len;
{
	int fd;

	fd = open (RANDOM_DEVICE, O_RDONLY);
	if (fd == -1) {
		log_err ("open(" RANDOM_DEVICE "): ", strerror(errno),
				0,0,0,0);
		return 1;
	}

	if (lx_setalloc (rk, len)) return 1;

	if (read (fd, rk->s, len) != len) {
		lx_free (rk);
		return 1;
	}

	rk->len = len;
	return 0;
}
