#include <stdlib.h>
#include "misc.h"

/* NAW_INIT_DEBUG: debug level: 0-9 */
static inline void setup_env_debug(void) {
    char *debugenv = getenv ("NAW_INIT_DEBUG");

    if (debugenv && (naw_debug_level = *debugenv)) {
        if (naw_debug_level > '9' || naw_debug_level < '0')
            die_badenv ("NAW_INIT_DEBUG");
        naw_debug_noisy = 1;
    } else if ((debugenv = getenv("NAW_DEBUG")) &&
            (naw_debug_level = *debugenv)) {
        if (naw_debug_level > '9' || naw_debug_level < '0')
            die_badenv ("NAW_DEBUG");
    } else return;

    naw_debug_level -= '0';
}

/* XXX: NAW_MODULE_FLUSHFILE: alternate flush file to monitor */
static inline void setup_env_flushfile(void) {
        /*
	module_flushfile = getenv ("NAW_MODULE_FLUSHFILE");
        if (!module_flushfile) module_flushfile = NAW_FLUSH_TRIGGER;
        */
}

/* XXX: NAW_INIT_BLOCK: use forced software blocking? */
static inline void setup_env_block(void) {
	char *blockenv = getenv ("NAW_INIT_BLOCK");

	if (blockenv && *blockenv != '0') force_block = 1;
}

/* XXX: NAW_MODULE_DIR: alternate module directory */
static inline void setup_env_moduledir(void) {
	module_dir = getenv ("NAW_MODULE_DIR");
}

/* XXX: NAW_FAIL_OPEN: if 'allow' modules fail to register, accept anyway.
 * (default is to deny the connection) */
static inline void setup_env_failopen(void) {
	char *failopen = getenv ("NAW_FAIL_OPEN");

	if (failopen && *failopen != '0') fail_open = 1;
}

static inline void setup_env_config(void) {
    char *cfg;
    cfg = getenv("NAW_CONFIG_CLI");
    if (cfg) cdb_config[INIT_CLI] = cfg;

    cfg = getenv("NAW_CONFIG_SRV");
    if (cfg) cdb_config[INIT_CLI] = cfg;
}

void setup_env_opt(void) {
	setup_env_debug();
	setup_env_block();
	setup_env_moduledir();
	setup_env_flushfile();
	setup_env_failopen();
    setup_env_config();
}

